/*************************************************************************
*  Copyright (c) 1989-1992 Micro Digital Associates, Inc.
*                  All Rights Reserved.
*
*  MODULE: BUCKET.HPP - Bucket Character Exchange
*
*  DESRIPTION:
*              This header file contins the class definition for the
*              bucket class. This class is derived from the SIOBus class. 
*
*
*  AUTHOR: Rick Evans 
*
*
*  UPDATE LOG
*
*************************************************************************/

#ifndef __BUKEXCHG_HPP
#define __BUKEXCHG_HPP     1

#include      "siobus.hpp"
#include		  <xtypes.h>	

class Bucket : public SIOBus
{

public:

   //---- constructors ------
   // create just the bucket
   Bucket();
   // create a bucket and a message for the buffer.
   Bucket( word size );
   // create a bucket from c level.
   Bucket( CXCB_PTR p );

   //----- methods ----------
private:
   // GetChar and PutChar are intended to be used in the device driver/
   virtual  int      GetChar();
   virtual  BOOLEAN  PutChar( char achar );

   //---- destructor ------
   ~Bucket();
};

#endif
//EOF
