/*
* DDEMO.HPP                                                 Version 1.0
*
* Copyright (c) 1990-1993 Micro Digital Associates, Inc. 
*               All Rights Reserved.
*
* Author: Rick Evans
*
***********************************************************************/

#include <DProcess.hpp>
#include <Task.hpp>
#include <semaphor.hpp>
#include <counter.hpp>


/* process class pointer */
extern   DProcess*   DPP;
extern   Counter*    TicksCp;

extern   Sem*        InClibSp;
extern   Sem*        InDosSp;
extern   Sem*        TsSp;

extern   Task*       ExitxTp;
extern   Task*       IdleTp;   
extern   Task*       TimeOutTp;


extern PXCB_PTR        kbd_pipe;      /* pipe used by keyin() */
extern PXCB_PTR        op_pipe;       /* operation input pipe */

/* extern c functions */
extern "C" {
void        disk_demo_main(void);
void        errgen_main(void);
void        opcon_main(void);
void        preempter_main(void);
void        sleeper_main(void);
void        swap_screen(void);
}


/* address markers -- see ddseg.asm */

extern byte near  bnheap;        /* beginning of near heap */
extern byte near  bndar;         /* beginning of near dar space */
extern byte near  enheap;        /* end of near heap */
extern byte near  endar;         /* end of near dar space */

#if    LARGE_DATA
extern byte far   bstack;        /* beginning of stack pool */
extern byte far   estack;        /* end of stack pool */
#else
extern byte       bstack;        /* beginning of stack pool */
extern byte       estack;        /* end of stack pool */
#endif

extern byte       temp_heap[];


/* function prototype */
void _cdecl appl_init();
