/*************************************************************************
*  Copyright (c) 1989-1993 Micro Digital Associates, Inc.
*                  All Rights Reserved.
*
*  MODULE: DPROCESS.HPP  Process class.
*
*  DESRIPTION:
*              This class is used to build the process for the dos
*              demo. It contains the tasks that are needed to run the demo.
*              By using a process class the objects that are required
*              for a particular job are contained in one place. Also
*              the interface for that job ( process ) can be controled.
*
*  AUTHOR: Rick Evans 
*
*
*  UPDATE LOG
*
*************************************************************************/
#ifndef  __DPROCESS_HPP
#define __DPROCESS_HPP  1

#include <process.hpp>
#include <task.hpp>

//Class
class DProcess:  public Process
{
public:
   Task     DiskDemo;
   Task     ErrGen;
   Task     OpCon;
   Task     Preempter;
   Task     Sleeper;

   //-------- Constructors --------
   DProcess(   const void(*Task1)(), const void(*Task2)(), 
               const void(*Task3)(), const void(*Task4)(), 
               const void(*Task5)() );
            

   //---------- Methods -----------
   virtual BOOLEAN   Start();
   virtual BOOLEAN   ShutDown();
   //--------- Destructor ---------
   ~DProcess() { ShutDown(); }

};
#endif
//EOF
