/*************************************************************************
*  Copyright (c) 1989-1993 Micro Digital Associates, Inc.
*                  All Rights Reserved.
*
*  MODULE: EVENT.HPP
*
*  DESRIPTION:
*              This class is the event class. It functions like the
*              smx event table.     
*
*  AUTHOR: Rick Evans 
*
*
*  UPDATE LOG
*
*************************************************************************/
#ifndef  __EVENT_HPP
#define __EVENT_HPP  1

#include    <xtypes.h>     /* smx type and structure definitions */


//Class
class Event
{
private:

   ET_PTR     EventTP;

public:

   //-------- Constructors --------
   Event( word num );
   Event( const Event& t );
   Event( ET_PTR p );


   //---------- Methods -----------
   BOOLEAN  ResetFlags( int mask );
   BOOLEAN  SetFlags( int mask );
   int      TestFlags( int mask, word timeOut=INF );
   int      TestFlagsStop( int mask, word timeOut=INF );

   //--------- Destructor ---------
   ~Event();         
};
#endif
//EOF
