/*************************************************************************
*  Copyright (c) 1989-1992 Micro Digital Associates, Inc.
*                  All Rights Reserved.
*
*  MODULE: PIPE.HPP - Pipe Class
*
*  DESRIPTION:
*              This header file contins the class definition for the
*              pipe class. This class is derived from the SIOBus class. 
*
*
*  AUTHOR: Rick Evans 
*
*
*  UPDATE LOG
*
*************************************************************************/

#ifndef __PIPE_HPP
#define __PIPE_HPP     1


#include    <xtypes.h>
#include    "siobus.hpp"

class Pipe : public SIOBus
{

   PXCB_PTR       PipeCBP;

public:

   //---- constructors ------
   // create a Pipe and a message for the buffer.
   Pipe( word size );
	// c upgrade constructor
   Pipe( PXCB_PTR p );

   //----- methods ----------
protected:
   // GetChar and PutChar are intended to be used in the device driver/
   virtual  int      GetChar();
   virtual  BOOLEAN  PutChar( int achar );

public:
   int      PGetChar( word TimeOut=INF );
   int      PGetCharStop( word TimeOut=INF );

   BOOLEAN  PPutChar( char achar, word Timeout=INF );
   BOOLEAN  PPutCharStop( char achar, word Timeout=INF );

   //---- destructor ------
   ~Pipe();
};

#endif
//EOF

